import nGeneFastICA
import Testcases_nGeneDL_LinearAlgebra
from nGeneVascularSystem import *
import requests
import numpy as np
import matplotlib.pyplot as plt
import certifi
import urllib3
from urllib3.exceptions import InsecureRequestWarning
#########################
from pyscript import display
import pandas as pd
#import panel as pn
#pn.extension()
from pyweb import pydom
from pyodide.http import open_url
from js import console
##########################
from sklearn.model_selection import train_test_split
from sklearn.preprocessing import StandardScaler
from sklearn.svm import SVC
from sklearn.metrics import classification_report, confusion_matrix
from sklearn.utils import resample # downsample the dataset
from sklearn import preprocessing # scale and center data
from sklearn.decomposition import PCA # to perform PCA to plot the data
from sklearn.model_selection import GridSearchCV # this will do cross validation  from sklearn.metrics import confusion_matrix # this creates a confusion matrix
import matplotlib.colors as colors
##########################
from js import document, fetch, URL

########################################################################################
def log(message):
    print(message)        
    console.log(message)  

def run_test_early_stopping(event):
    for activation_fn in ["SoftPlus"]: #, "sigmoid", "ReLU", "leaky_ReLU", "tanh"]:
        print(f"\n\t=== Training Termination for {activation_fn} ===", end="")
        Testcases_nGeneDL_LinearAlgebra.test_early_stopping(activation_fn=activation_fn)

##########################################
epochs, threshold_based_early_stopping, hidden_layer, plot, visualize, activation_fn = (
    50000,
    True,
    [10],
    False,
    False,
    "SoftPlus"
)

def run_test_parity_check(event):
    print("\n\t=== parity 0110 1001 ===", end='')
    Testcases_nGeneDL_LinearAlgebra.test_parity_check(
        epochs=epochs,
        threshold_based_early_stopping=threshold_based_early_stopping,
        hidden_layer=hidden_layer,
        plot=plot,
        visualize=visualize,
        activation_fn=activation_fn
    )

def run_test_xor(event):
    print("\n\t=== xor 0110 ===", end='')
    Testcases_nGeneDL_LinearAlgebra.test_xor(
        epochs=epochs,
        threshold_based_early_stopping=threshold_based_early_stopping,
        hidden_layer=hidden_layer,
        plot=plot,
        visualize=visualize,
        activation_fn=activation_fn
    )

def run_test_majority_function(event):
    print("\n\t=== majority 0001 0111 ===", end='')
    Testcases_nGeneDL_LinearAlgebra.test_majority_function(
        epochs=epochs,
        threshold_based_early_stopping=threshold_based_early_stopping,
        hidden_layer=hidden_layer,
        plot=plot,
        visualize=visualize,
        activation_fn=activation_fn
    )

def run_test_multiplexer(event):
    print("\n\t=== multiplexer 01010101 01010101 ===", end='')
    Testcases_nGeneDL_LinearAlgebra.test_multiplexer(
        epochs=epochs,
        threshold_based_early_stopping=threshold_based_early_stopping,
        hidden_layer=hidden_layer,
        plot=plot,
        visualize=visualize,
        activation_fn=activation_fn
    )

def run_test_equality_testing(event):
    print("\n\t=== equality 10000000 00000001 ===", end='')
    Testcases_nGeneDL_LinearAlgebra.test_equality_testing(
        epochs=epochs,
        threshold_based_early_stopping=threshold_based_early_stopping,
        hidden_layer=hidden_layer,
        plot=plot,
        visualize=visualize,
        activation_fn=activation_fn
    )


def run_test_classification_xor(event):
    epochs, threshold_based_early_stopping, single_hidden_layer, double_hidden_layer, plot, visualize, activation_fn = (
        50000,
        True,
        [10],
        [5, 5],
        False,
        False,
        "SoftPlus"
    )

    print(f"\n\t=== classification for xor with no hidden layer vs hidden layers ===")
    print("(1) No hidden layer")
    Testcases_nGeneDL_LinearAlgebra.test_classification_xor(
        epochs=epochs,
        threshold_based_early_stopping=threshold_based_early_stopping,
        hidden_layer=[],
        plot=plot,
        visualize=visualize,
        activation_fn=activation_fn
    )

    print(f"\n(2) Single hidden layer {single_hidden_layer}")
    Testcases_nGeneDL_LinearAlgebra.test_classification_xor(
        epochs=epochs,
        threshold_based_early_stopping=threshold_based_early_stopping,
        hidden_layer=single_hidden_layer,
        plot=plot,
        visualize=visualize,
        activation_fn=activation_fn
    )

def run_test_classification_parity_check(event):
    epochs, threshold_based_early_stopping, single_hidden_layer, double_hidden_layer, plot, visualize, activation_fn = (
        50000,
        True,
        [10],
        [5, 5],
        False,
        False,
        "SoftPlus"
    )

    print(f"\n\t=== classification for parity check with no hidden layer vs hidden layers 0110 1001 1001 0110 ===")
    print("(1) No hidden layer")
    Testcases_nGeneDL_LinearAlgebra.test_classification_parity_check(
        epochs=epochs,
        threshold_based_early_stopping=threshold_based_early_stopping,
        hidden_layer=[],
        plot=plot,
        visualize=visualize,
        activation_fn=activation_fn
    )

    print(f"\n(2) Single hidden layer {single_hidden_layer}")
    Testcases_nGeneDL_LinearAlgebra.test_classification_parity_check(
        epochs=epochs,
        threshold_based_early_stopping=threshold_based_early_stopping,
        hidden_layer=single_hidden_layer,
        plot=plot,
        visualize=visualize,
        activation_fn=activation_fn
    )

    print(f"\n(3) Double hidden layers {double_hidden_layer}")
    Testcases_nGeneDL_LinearAlgebra.test_classification_parity_check(
        epochs=epochs,
        threshold_based_early_stopping=threshold_based_early_stopping,
        hidden_layer=double_hidden_layer,
        plot=plot,
        visualize=visualize,
        activation_fn=activation_fn
    )

def run_test_classification_iris(event):
    ##########################################################################
    print("\n\t=== classification_iris ===")
    Testcases_nGeneDL_LinearAlgebra.test_classification_iris()

def run_test_vanishing_gradient(event):
    ##########################################################################
    print("\n\t=== Vanishing Gradient Descent ===")
    Testcases_nGeneDL_LinearAlgebra.test_vanishing_gradient(plot=False)

def run_linear_algebra_bias_and_depth_comparison(event):
    ##########################################################################
    print(
        "\n\t=== A Linear Algebra Perspective on the Impact of Bias Term Integration on Neural Network Training ===\n" +
        "nGeneDL_LinearAlgebra (bias as weight, depth considered)\nvs. nGeneDL_Prototype (bias separate, depth not considered)")
    Testcases_nGeneDL_LinearAlgebra.linear_algebra_bias_and_depth_comparison()
    


############################################################################################
############################################################################################
def display_image(url):
    img = document.createElement('img')
    img.src = url
    img.alt = 'Loaded Image'
    img.style.maxWidth = '100%'
#    output_div = document.getElementById('output_webcrawler')
    output_div = document.getElementById('output_pulmonaryVascularNetwork')
    output_div.appendChild(img)
    
def run_pulmonaryVascularNetwork(event):
    # Set up a matplotlib figure and axis
    plt.figure(figsize=(6, 6))
    ax = plt.gca()

    # Create instances of DirectedGraphDrawer with different configurations
    graph_drawer1 = DirectedGraphDrawer(orientation_degrees=60, root_pos=(1, 0.6))  # Left upper lobe
    graph_drawer2 = DirectedGraphDrawer(orientation_degrees=100, root_pos=(1, 0.2))  # Left lower lobe
    graph_drawer3 = DirectedGraphDrawer(orientation_degrees=300, root_pos=(0, 0.5))  # Right upper lobe
    graph_drawer4 = DirectedGraphDrawer(orientation_degrees=280, root_pos=(0, 0.3))  # Right middle lobe
    graph_drawer5 = DirectedGraphDrawer(orientation_degrees=240, root_pos=(0, 0.1))  # Right lower lobe

    # Add external edges
    graph_drawer1.add_external_edge((1.2, 0.4), 0)  # Connect to root node 0
    graph_drawer2.add_external_edge((1.3, 0.2), 0)  # Connect to root node 0
    graph_drawer3.add_external_edge((0.8, 0.3), 0)  # Connect to root node 0
    graph_drawer4.add_external_edge((0.9, 0.3), 0)  # Connect to root node 0
    graph_drawer5.add_external_edge((0.9, 0.1), 0)  # Connect to root node 0

    # Draw each graph on the same matplotlib axis
    graph_drawer1.draw_graph(ax, label="Lt. Upper Lobe", label_pos=(1.7, 0.9))
    graph_drawer2.draw_graph(ax, label="Lt. Lower Lobe", label_pos=(1.7, 0.1))
    graph_drawer3.draw_graph(ax, label="Rt. Upper Lobe", label_pos=(-0.2, 0.9))
    graph_drawer4.draw_graph(ax, label="Rt. Middle Lobe", label_pos=(-0.2, 0.4))
    graph_drawer5.draw_graph(ax, label="Rt. Lower Lobe", label_pos=(-0.2, -0.2))

    # Set the title for the plot
    plt.title( "Pulmonary Arterial Vascular System, drawn by using Python networkx");
    plt.show()
    display(plt, target="output_pulmonaryVascularNetwork")
    display(plt.subplots(), target="output_pulmonaryVascularNetwork")

    # Display a comparative image from wikipedia
    urls = ["https://ngene.org/src/2119_Pulmonary_Circuit.jpg"]
    for url in urls:
        display_image(url)

########################################################################################        
########################################################################################
def fetch_wav_and_convert_to_numpy(url):
    response = requests.get(url, verify=certifi.where())
    if response.status_code != 200:
        print("Failed to download the file:", url)
        return None
    wav_bytes = response.content
    audio_data = np.frombuffer(wav_bytes[44:], dtype=np.int16)
    normalized_audio = audio_data / np.max(np.abs(audio_data))
    return normalized_audio

def plot_waveforms(signals, sample_rate, titles, colors):
    total_num_plots = len(signals)
    plt.figure(figsize=(6.5, 3 * total_num_plots), dpi=100)

    for i, (audio_array, title, color) in enumerate(zip(signals, titles, colors), start=1):
        time_axis = np.linspace(0, len(audio_array) / sample_rate, num=len(audio_array))
        plt.subplot(total_num_plots, 1, i)
        plt.plot(time_axis, audio_array, label=title, color=color)
        plt.title(title)
        plt.xlabel("Time (seconds)")
        plt.ylabel("Amplitude (normalized)")
        plt.legend()
        plt.tight_layout()

    plt.show()
    display(plt, target="output_ica")    
    display(plt.subplots(), target="output_ica")

############################################################################################    
def run_ica(event):
    urllib3.disable_warnings(InsecureRequestWarning)
        
    # URLs corrected to .wav
    # heart_sound_url = "https://raw.githubusercontent.com/nGene-org/SVM/main/heart_sound.wav"
    # lung_sound_url = "https://raw.githubusercontent.com/nGene-org/SVM/main/lung_sound.wav"
    heart_sound_url = pydom["input#heartSound-url"][0].value
    lung_sound_url = pydom["input#lungSound-url"][0].value
    
    log(f"Heart Sound URL: {heart_sound_url}")
    log(f"Lung  Sound URL: {lung_sound_url}\n")
    
    # Fetch and convert audio data to numpy arrays
    heart_sound = fetch_wav_and_convert_to_numpy(heart_sound_url)
    lung_sound = fetch_wav_and_convert_to_numpy(lung_sound_url)

    # Assuming a common sample rate for audio files
    sr = 44100  # Sample rate in Hz

    # Stack both signals for ICA
    S = np.vstack((heart_sound, lung_sound))

    # Mix signals
    A = np.array([[1, 1], [0.5, 2]])
    X = A @ S

    # Perform FastICA
    fastICA = nGeneFastICA.FastICA(num_sources=2)
    components = fastICA.decompose_mixtures(X)

    # Log the ICA components
    log(f"ICA Components:\nComponent 1: {components[0, :]}\nComponent 2: {components[1, :]}\n")
            
    # Preparing data for plotting
    signals = [heart_sound, lung_sound, X[0, :], X[1, :], components[0, :], components[1, :]]
    titles = ["Original Heart Sound Waveform", "Original Lung Sound Waveform",
              "Mixed Signal 1", "Mixed Signal 2",
              "Separated Signal 1", "Separated Signal 2"]
    colors = ['red', 'blue', 'green', 'orange', 'purple', 'cyan']

    # Plotting
    plot_waveforms(signals, sr, titles, colors)

    # Log the plotting result
    log("Waveforms have been plotted successfully.\n")

############################################################################################


########################################################################################
class DataFrameEditor:
    def __init__(self):
        self.df = None
        self.big_text = None
        self.show_all = False
        self.enclosing_url = False
        
    def log(self, message):
        print(message)
        console.log(message)
        
    def updateTextInput(self):
        selected_url = pydom["select#csv-url-select"][0].value
        pydom["input#txt-url"][0].value = selected_url
        self.log(f"URL updated to: {selected_url}")
        
    def loadFromURL(self, event):
        pydom["div#pandas-output-inner"].html = ""
        url = pydom["input#txt-url"][0].value
        
        self.log(f"Trying to fetch CSV from {url}")
        self.df = pd.read_csv(open_url(url))
        
        # Convert DataFrame to HTML and display
        html = self.df.to_html()
        pydom["div#pandas-output-inner"].html = html
        pydom["div#pandas-output"].style["display"] = "block"

        self.log(self.df.info())
        self.log('\n')
        
    def modifyCell(self, event):
        if self.df is None:
            self.log("DataFrame is not loaded. Attempting to load...")
            self.loadFromURL(event)
            if self.df is None:
                self.log("Failed to load DataFrame. Please ensure a valid URL is selected and try again.")
                return
        
        cell_to_modify = pydom["input#inputB"][0].value  # e.g., "B2"
        new_value = pydom["input#inputA"][0].value  # New value to put into the cell
        
        if not cell_to_modify or not new_value:
            self.log("Please specify both the cell and the new value.")
            return
        
        # Convert cell notation to DataFrame indices
        col = ord(cell_to_modify[0].upper()) - ord('A')
        row = int(cell_to_modify[1:]) - 1
        
        # Update the DataFrame
        try:
            self.df.iloc[row, col] = new_value
            self.log(f"Cell {cell_to_modify} updated to: {new_value}")
        except Exception as e:
            self.log(f"Error updating cell {cell_to_modify}: {str(e)}")
            return

        self.displayAllData(event)
        # Display the updated DataFrame
        #html = self.df.to_html()
        #pydom["div#pandas-output-inner"].html = html
        #pydom["div#pandas-output"].style["display"] = "block"
        
        # Clear the inputs after modification
        # pydom["input#inputA"][0].value = ""
        # pydom["input#inputB"][0].value = ""

    def createSpreadsheet(self, event):
        # Read the number of rows and columns from the input fields
        num_rows = int(pydom["input#num-rows"][0].value)
        num_cols = int(pydom["input#num-cols"][0].value)
        
        # Generate a DataFrame with specified dimensions
        data = np.random.randint(0, 100, size=(num_rows, num_cols))
        columns = [chr(65+i) for i in range(num_cols)]  # Generate column names A, B, C, etc.
        self.df = pd.DataFrame(data, columns=columns)

        self.displayAllData(event)
        
        # Convert DataFrame to HTML and display
        #html = self.df.to_html()
        #pydom["div#pandas-output-inner"].html = html
        #pydom["div#pandas-output"].style["display"] = "block"
        # Log the DataFrame creation
        #self.log(f"{num_rows}x{num_cols} DataFrame created and displayed.")

    def changeHeader(self, event):
        # Retrieve the new headers from the input field
        new_headers_input = pydom["input#new-headers"][0].value
        new_headers = [header.strip() for header in new_headers_input.split(',')]

        num_columns = len(self.df.columns)

        # Adjust the log message to appear only once for any mismatch
        if len(new_headers) != len(self.df.columns):
            self.log("The number of new headers does not match the number of columns in the DataFrame.")

        # Prepare the new headers list
        updated_headers = new_headers[:num_columns]  # Take as many new headers as we can fit
        
        # If there are fewer new headers than columns, extend the updated_headers with the original ones
        if len(new_headers) < num_columns:
            self.log("Fewer new headers provided than existing columns. Only the first few headers will be replaced.")
            # Extend the updated_headers with the remaining original headers
            updated_headers.extend(self.df.columns[len(new_headers):])
            
        # Update the DataFrame's column headers
        self.df.columns = updated_headers

        self.displayAllData(event)
        
    def displayAllData(self, event):
        # Convert DataFrame to HTML and display
        # html = self.df.to_html()
        html = self.df.to_html(classes=["table", "table-bordered", "table-hover"], border=1, index=True)
        
        #html = self.table._get_model(None, None, None).get_root()
            
        pydom["div#pandas-output-inner"].html = html
        pydom["div#pandas-output"].style["display"] = "block"

        #####################################

    def updateShowAllState(self, event=None):
        # show_all = pydom["input#chk-show-all"][0].value  # Get the state of the checkbox
        # self.log(f"[updateShowAllState1] checked: {show_all}")

        self.show_all = not self.show_all
        #self.log(f"[updateShowAllState] showAll: {self.show_all}")

    def updateEnclosingStatus(self, event=None):
        self.enclosing_url = not self.enclosing_url
    
    def displayLinksOnly(self, event):
        # Convert the DataFrame to HTML without the index
        html = self.df.to_html(index=False, columns=['Links'])
        # Update the HTML of the designated div to display the DataFrame
        pydom["div#pandas-output-inner"].html = html
        pydom["div#pandas-output"].style["display"] = "block"
                        
        
    def displayPartialData(self, event):
        if self.show_all:
            self.displayAllData(event)
            return

        max_rows = int(pydom["input#max-rows"][0].value)
        max_cols = int(pydom["input#max-cols"][0].value)
        
        max_rows, max_cols = min(max_rows, self.df.shape[0]), min(max_cols, self.df.shape[1])
        display_df = self.df.iloc[:max_rows, :max_cols]
            
        # Convert the DataFrame (or its subset) to HTML
        html = display_df.to_html()
        
        # Update the HTML of the designated div to display the DataFrame
        pydom["div#pandas-output-inner"].html = html
        pydom["div#pandas-output"].style["display"] = "block"
        
        # Log the action
        #self.log("Data displayed successfully.")

    def logSpecifiedChars(self, event):
        # Log a message to indicate the function is triggered
        # self.log("Processing text area content")

        # Retrieve the text from the textarea
        self.big_text = pydom["textarea#big-text-input"][0].value

        # Retrieve the specified number of characters to log
        num_chars_to_log = int(pydom["input#num-chars-to-log"][0].value)
        
        # Safely adjust the num_chars_to_log if it exceeds the length of big_text
        num_chars_to_log = min(num_chars_to_log, len(self.big_text))
        
        # Extract the specified number of characters
        specified_chars = self.big_text[:num_chars_to_log]
    
        # Log the specified number of characters to the console
        self.log(f"First {num_chars_to_log} characters: {specified_chars}")

    def extractLinks(self, event):
        # Retrieve HTML content from the textarea
        html_content = pydom["textarea#big-text-input"][0].value
        
        # Retrieve the div id from the input field, if provided
        div_id = pydom["input#div-id-input"][0].value

        # Initialize or prepare self.df with only a 'Links' column
        self.df = pd.DataFrame(columns=['Links'])
        
        links = []
        
        # Check if a div id is provided and attempt to isolate the div
        if div_id:
            start_div = html_content.find(f'id="{div_id}"')
            if start_div != -1:
                end_div = html_content.find('</div>', start_div)
                html_content = html_content[start_div:end_div]
                
        # Extract links from the (possibly isolated) content
        start_index = html_content.find('href="')
        links_list = []  # Temporary list to store links
        while start_index != -1:
            start_index += len('href="')
            end_index = html_content.find('"', start_index)
            link = html_content[start_index:end_index]
            if "chapter-" in link or not div_id:  # Extract links with "chapter-" or any link if no div id is provided
                links.append(link)  # Append the link to the list
                self.log(link)  
                if self.enclosing_url:
                    links_list.append([f'"{link}",'])  # Prepare a row with only the link enclosed in quotes
                else:
                    links_list.append([f'{link}'])  # Prepare a row with only the link enclosed in quotes

            start_index = html_content.find('href="', end_index)
            
        # Convert links_list to a DataFrame
        links_df = pd.DataFrame(links_list, columns=['Links'])
        
        # No need to concatenate as self.df should only contain the newly extracted links
        self.df = links_df
        
        self.displayLinksOnly(event)
        
    def fetchSliderValue(self, event):
        slider_value = pydom["input#slider-bar"][0].value
        log_message = f"Current slider value: {slider_value}"
        self.log(log_message)
        # Update the display value as well
        pydom["div#slider-value"].innerText = slider_value

        #slider_value = document.getElementById('slider-bar').value
        document.getElementById('slider-value').innerText = slider_value
        #print(f"Current slider value: {slider_value}")
        #self.log(f"Current slider value: {slider_value}")
        
dfe = DataFrameEditor()

############################################################################################

log(f"Now Initialized.\n")
